import QtQuick 2.12
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.0

Page {
    id: page
    width: 600
    height: 400
    property alias tiPwd: tiPwd
    property alias tiUsr: tiUsr
    property alias tiBroker: tiBroker
    property alias btConnecta: btConnecta
    property alias lbEstatMqtt: lbEstatMqtt

    header: Label {
        text: qsTr("Connexió MQTT")
        font.pixelSize: Qt.application.font.pixelSize * 2
        padding: 10
    }


    ColumnLayout {
        id: clCentral
        x: 197
        y: 81
        width: 297
        height: 156
        anchors.verticalCenter: parent.verticalCenter
        anchors.verticalCenterOffset: -50
        anchors.horizontalCenter: parent.horizontalCenter

        ColumnLayout {
            id: clDadesBroker
            Layout.bottomMargin: 50
            Layout.preferredHeight: 70
            Layout.preferredWidth: 205

            RowLayout {
                id: rlBroker
                Layout.fillHeight: true
                Layout.fillWidth: true

                Label {
                    id: lbBroker
                    text: qsTr("Broker: ")
                    font.bold: true
                    color: "#0000ff"
                    Layout.fillHeight: true
                }

                TextInput {
                    id: tiBroker
                    text: "ws://formacio.things.cat:9001"
                    font.pixelSize: 12
                    Layout.fillHeight: true
                    Layout.fillWidth: true
                    Layout.preferredHeight: 20
                    Layout.preferredWidth: 245
                }
            }

            RowLayout {
                id: rlUser
                Layout.fillHeight: true
                Layout.fillWidth: true

                Label {
                    id: lbUsr
                    text: qsTr("Usuari: ")
                    font.bold: true
                    color: "#0000ff"
                    Layout.fillHeight: true
                }

                TextInput {
                    id: tiUsr
                    text: qsTr("ecat")
                    font.pixelSize: 12
                    Layout.fillHeight: true
                    Layout.fillWidth: true
                    Layout.preferredHeight: 20
                    Layout.preferredWidth: 80
                }
            }

            RowLayout {
                id: rlPwd
                Layout.fillHeight: true
                Layout.fillWidth: true

                Label {
                    id: lpPwd
                    text: qsTr("Contrasenya: ")
                    font.bold: true
                    color: "#0000ff"
                    Layout.fillHeight: true
                    Layout.fillWidth: false
                }

                TextInput {
                    id: tiPwd
                    text: qsTr("clotClot")
                    font.pixelSize: 12
                    verticalAlignment: Text.AlignVCenter
                    Layout.alignment: Qt.AlignLeft | Qt.AlignTop
                    Layout.fillHeight: true
                    Layout.fillWidth: true
                    echoMode: TextInput.Password
                    Layout.preferredHeight: 20
                    Layout.preferredWidth: 80
                }
            }
        }

        Label {
            id: lbEstatMqtt
            text: qsTr("Desconnectat")
            font.pixelSize: 36
            font.bold: true
            Layout.fillHeight: true
            Layout.fillWidth: true
            Layout.alignment: Qt.AlignHCenter | Qt.AlignVCenter
        }
    }

    Button {
        id: btConnecta
        x: 252
        text: qsTr("Connecta")
        anchors.top: clCentral.bottom
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.topMargin: 33
    }
}
