//import QtQuick 2.12
//import QtQuick.Controls 2.5
import QtQuick
import QtQuick.Controls

import desDel.rerefons 1.0

ApplicationWindow {
    width: 640
    height: 480
    visible: true
    title: qsTr("Tabs")

    RereFons{
        id: rf

        onCmptChanged: {
            console.log(nCmpt);
        }
        onVSignalMqttConnected: {
            console.log("MQTT connectat!");
            swipeView.actualitzaColorInfoMqtt("#00ff00");
            p1.lbEstatMqtt.text = "Connectat!";
            p1.btConnecta.text = "Desconnecta";
            p2.cbLedW.enabled = true;
        }
        onVSignalMqttConnecting: {
            console.log("MQTT connectant");
            swipeView.actualitzaColorInfoMqtt("#0000ff");
            p1.lbEstatMqtt.text = "Connectant";
            p1.btConnecta.text = "Desconnecta";
            p2.cbLedW.enabled = false;
        }
        onVSignalMqttDisconnected: {
            console.log("MQTT desconnectat");
            swipeView.actualitzaColorInfoMqtt("#ff0000");
            p1.lbEstatMqtt.text = "Desconnectat";
            p1.btConnecta.text = "Connecta";
            p2.cbLedW.enabled = false;
        }
        onMqttRebut: {
            p2.lbBtI35.text = rf.szRebut;
        }
    }
    SwipeView {
        id: swipeView
        anchors.fill: parent
        currentIndex: tabBar.currentIndex

        function actualitzaColorInfoMqtt(c){
            p1.lbEstatMqtt.color = c;
        }

        function llegeixParametresBroker(){
            console.log("Broker: " + p1.tiBroker.text);
            console.log("Usuari: " + p1.tiUsr.text);
            console.log("Contrasenya: " + p1.tiPwd.text);
        }

        Page1Form {
            id: p1
            lbEstatMqtt.color: "#ff0000"

            btConnecta.onClicked: {
                if(btConnecta.text == "Connecta"){
                    rf.szBroker = "C,"+tiBroker.text+","+tiUsr.text+","+tiPwd.text+","+p2.tiMac.text;
                }else{
                    rf.szBroker = "D,"+tiBroker.text+","+tiUsr.text+","+tiPwd.text+","+p2.tiMac.text;
                }
            }
        }

        Page2Form {
            id: p2
            cbLedW.enabled: false

            cbLedW.onClicked: {
                if(!cbLedW.checked){
                    console.log("Apaga led blanc");
                    rf.szPublica = "w,"+tiMac.text;
                }else{
                    console.log("Encén led blanc");
                    rf.szPublica = "W,"+tiMac.text;
                }
                // console.log(tiMac.text);
            }
        }
    }

    footer: TabBar {
        id: tabBar
        currentIndex: swipeView.currentIndex

        TabButton {
            text: qsTr("Connexió al broker")
        }
        TabButton {
            text: qsTr("Interacció")
        }
    }
}
