#include "rerefons.h"
#include <QDebug>
#include <QTimer>

RereFons::RereFons(QObject *parent) : QObject(parent)
{
    m_nCmpt = 0;

    QTimer *timer = new QTimer(this);
    connect(timer,SIGNAL(timeout()),
            this,SLOT(vActualitza()));
    // timer->start(500);

    mqtt = new MqttBasic;

    connect(mqtt,SIGNAL(vSignalMqttConnected()),this,SIGNAL(vSignalMqttConnected()));
    connect(mqtt,SIGNAL(vSignalMqttConnecting()),this,SIGNAL(vSignalMqttConnecting()));
    connect(mqtt,SIGNAL(vSignalMqttDisconnected()),this,SIGNAL(vSignalMqttDisconnected()));

    connect(mqtt,SIGNAL(vSignalMqttConnected()),this,SLOT(vSubscripcions()));
    connect(mqtt,SIGNAL(vSignalMqttMsgRcv(QString,QString)),this,SLOT(vMqttRebut(QString,QString)));
}

RereFons::~RereFons(){
    mqtt->vDisconnectBroker();
    delete mqtt;
}

QString RereFons::szBroker(){
    return m_szNomBroker;
}

void RereFons::setBroker(const QString &szValue){
    QStringList qsL = szValue.split(QLatin1Char(','));

    m_szNomBroker = qsL[1];
    m_szUsrBroker = qsL[2];
    m_szPwdBroker = qsL[3];
    m_szMac = qsL[4];

    qDebug() << "Des de C++. Ordre: "<< qsL[0] << ". Broker: " << m_szNomBroker << ". Usuari: " << m_szUsrBroker << ". Contrasenya: " << m_szPwdBroker << ". MAC: " << m_szMac;

    if(qsL[0] == "C"){ // C: Connecta broker
        qDebug() << "Connecta broker";
        //mqtt->vSetBroker(m_szNomBroker,MQTT_PORT,m_szUsrBroker,m_szPwdBroker);
        mqtt->vSetWsBroker(m_szNomBroker,m_szUsrBroker,m_szPwdBroker,m_szMac);
        qDebug() << "m_szNomBroker: " << m_szNomBroker;
    }
    if(qsL[0] == "D"){ // D: Desconnecta broker
        qDebug() << "Desconnecta broker";
        mqtt->vDisconnectBroker();
    }

    emit brokerCanviat();
}

void RereFons::vSubscripcions(){
    QString qsTemaBtI35 = "/"+ m_szMac +"/btI35";
    mqtt->vTopicSubscription(qsTemaBtI35);
    qDebug() << "subscrit a " << qsTemaBtI35;
}

void RereFons::setPublica(const QString &szValue){
    QStringList qsL = szValue.split(QLatin1Char(','));

    QString qsTopic = "/"+qsL[1]+"/ledW";

    qDebug() << "Des de C++. Broker: " << m_szNomBroker;
    qDebug() << "Des de C++. Usuari: " << m_szUsrBroker;
    qDebug() << "Des de C++. Contrasenya: " << m_szPwdBroker;

    if(qsL[0] == "W"){ // W: Encén led blanc
        mqtt->vPublish(qsTopic,"1");
        qDebug() << "Publica tema: " << qsTopic << " amb valor: 1";
    }
    if(qsL[0] == "w"){ // w: Apaga led blanc
        mqtt->vPublish(qsTopic,"0");
        qDebug() << "Publica tema: " << qsTopic << " amb valor: 0";
    }
}

int RereFons::nCmpt(){
    return m_nCmpt;
}

void RereFons::setCmpt(const int &nC){
    m_nCmpt = nC;

    emit cmptChanged();
}

void RereFons::vActualitza(){
    m_nCmpt++;
    if(m_nCmpt > 100)
        m_nCmpt = 0;
    emit cmptChanged();
}

QString RereFons::szRebut(){
    return m_missatgeI35;
}

void RereFons::vMqttRebut(QString qsTema,QString qsMissatge){
    qDebug() << "Rebut tema: " << qsTema << " amb valor: " << qsMissatge;
    m_missatgeI35 = qsMissatge;

    emit mqttRebut();
}
