#ifndef REREFONS_H
#define REREFONS_H

#include <QObject>
#include "mqttbasic.h"

class RereFons : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString szBroker READ szBroker WRITE setBroker NOTIFY brokerCanviat)
    Q_PROPERTY(QString szPublica WRITE setPublica)
    Q_PROPERTY(QString szRebut READ szRebut NOTIFY mqttRebut)
    Q_PROPERTY(int  nCmpt READ nCmpt WRITE setCmpt NOTIFY cmptChanged)

public:
    explicit RereFons(QObject *parent = nullptr);
    ~RereFons();
    QString szBroker();
    QString szRebut();
    void setBroker(const QString &szValue);
    void setPublica(const QString &szValue);
    int nCmpt();
    void setCmpt(const int &nC);
    MqttBasic *mqtt;

signals:
    void brokerCanviat();
    void cmptChanged();

    void vSignalMqttConnected();
    void vSignalMqttConnecting();
    void vSignalMqttDisconnected();
    void mqttRebut();

private:
    QString m_szNomBroker;
    QString m_szUsrBroker;
    QString m_szPwdBroker;
    QString m_szMac;
    int m_nCmpt;
    QString m_missatgeI35;

public slots:
    void vActualitza();
    void vSubscripcions();
    void vMqttRebut(QString,QString);
};

#endif // REREFONS_H
